#!/bin/sh
# mv must fail when src and dest are mismatched directory/non-directory.

# Copyright (C) 2000-2024 Free Software Foundation, Inc.

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
print_ver_ mv

mkdir -p dir/file || framework_failure_
> file || framework_failure_


# These should both fail, but until fileutils-4.0q only the second one did.
returns_ 1 mv dir file > /dev/null 2>&1 || fail=1
returns_ 1 mv file dir > /dev/null 2>&1 || fail=1

Exit $fail
